import { StyleSheet } from 'react-native';
import { widthPercentageToDP } from 'react-native-responsive-screen';
export default ({ boxed, blur, withShadow, backgroundColor, }) => StyleSheet.create({
    animatedWrapper: {
        paddingHorizontal: boxed ? widthPercentageToDP('8%') : undefined,
        position: 'absolute',
        width: '100%',
        zIndex: 5,
        justifyContent: 'center',
        backgroundColor: withShadow ? backgroundColor : undefined,
        shadowColor: '#000',
        shadowRadius: 6.68,
        shadowOffset: {
            width: 0,
            height: 2,
        },
    },
    headerBackground: {
        position: 'absolute',
        height: '100%',
        width: boxed ? widthPercentageToDP('116%') : '100%',
        backgroundColor: blur ? 'rgba(255, 255, 255, 0.5)' : backgroundColor,
    },
});
