import React, { useState } from 'react';
import { initialWindowSafeAreaInsets } from 'react-native-safe-area-context';
import { Animated, } from 'react-native';
import AnimatedScreenContext from '../AnimatedScreenContext';
const AnimatedScreenWrapper = ({ children, onScroll, headerMaxHeight = 200, headerMinHeight = 70, avoidSafeArea = false, disableParallaxEffect, }) => {
    const [scrollY] = useState(new Animated.Value(0));
    const { top: safeTop } = initialWindowSafeAreaInsets || { top: 0 };
    return (<AnimatedScreenContext.Provider value={{
        headerMaxHeight: headerMaxHeight + (avoidSafeArea ? 0 : safeTop),
        headerMinHeight,
        onScroll,
        scrollY,
        disableParallaxEffect,
    }}>
      {children}
    </AnimatedScreenContext.Provider>);
};
export default React.memo(AnimatedScreenWrapper);
